config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  get 'home/index'
  root to: 'home#index'

  devise_for :users, only: :sessions
  devise_scope :user do
    get '/register', to: 'users/registrations#new', as: :new_user_register
    post '/register', to: 'users/registrations#create'
  end
  resources :users, only: %i[edit update]
  resources :posts do
    delete :delete_main_image_attachment, on: :member
    put :publish, on: :member
  end
end

app/models/application_record.rb
# frozen_string_literal: true

class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/post.rb
# frozen_string_literal: true

class Post < ApplicationRecord
  acts_as_taggable_on :tags

  enum status: %i[draft published], _default: 'draft'

  belongs_to :user
  has_rich_text :description
  has_one_attached :main_image

  validates :title, :description, presence: true
  validates :main_image, content_type: %w[image/png image/jpg image/jpeg],
                         dimension: { width: 1000, height: 1500 }

  before_update :write_published_at, if: :will_save_change_to_status?

  scope :own_posts, ->(user) { where(user_id: user.id) }

  private

  def write_published_at
    return if status_in_database.eql?('published')

    self.published_at = Time.now
  end
end

app/models/user.rb
# frozen_string_literal: true

class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable, :validatable

  validates :first_name, :last_name, :password_confirmation, presence: true
  validates :email, format: { with: /\A[^@\s]+@([^@.\s]+\.)+[^@.\s]+\z/ }

  has_many :posts
end

app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
  include Pundit

  protect_from_forgery with: :exception

  rescue_from Pundit::NotAuthorizedError, with: :user_not_authorized

  def user_not_authorized
    redirect_to root_path, alert: t('general.access_denied')
  end
end

app/controllers/home_controller.rb
# frozen_string_literal: true

class HomeController < ApplicationController
  expose :posts, lambda {
    Post.includes(:user, :tags).published.paginate(page: params[:page], per_page: 10)
  }

  def index
    render template: 'posts/index'
  end
end

app/controllers/posts_controller.rb
# frozen_string_literal: true

class PostsController < ApplicationController
  expose :posts, -> { all_posts }
  expose :post

  before_action :authenticate_user!, except: %i[index show]
  before_action only: %i[edit update destroy] do
    authorize post
  end

  def create
    post.user = current_user
    if post.save
      redirect_to(posts_path(own_posts: true), notice: t('.new_post_created'))
    else
      render :new
    end
  end

  def destroy
    post.destroy
    redirect_to posts_path(own_posts: true), notice: t('.deleted_successfully')
  end

  def update
    if post.update(post_params)
      redirect_to post_path(post.id), notice: t('.post_updated')
    else
      render :edit
    end
  end

  def show
    @post = Post.find_by(id: params[:id])

    redirect_to root_path, alert: t('.not_found') unless @post
  end

  def publish
    if post.draft? && post.published!
      redirect_to post_path(post.id), notice: t('.post_published_successfully')
    else
      flash.now[:alert] = t('.already published')
      render :edit
    end
  end

  def delete_main_image_attachment
    image = ActiveStorage::Attachment.find_by(id: params[:id])
    image&.purge
    redirect_back(fallback_location: request.referer, alert: t('.image_deleted_successfully'))
  end

  private

  def all_posts
    posts = if params[:own_posts]
              current_user.posts.includes(:user, :tags, :rich_text_description)
            else
              Post.includes(:user, :tags, :rich_text_description).published
            end
    posts.paginate(page: params[:page], per_page: 12)
  end

  def post_params
    params.require(:post)
          .permit(:title, :description, :main_image, :remove_main_image, :tag_list)
  end

  def authorize_user!
    authorize post
  end
end

app/controllers/users/registrations_controller.rb
# frozen_string_literal: true

module Users
  class RegistrationsController < Devise::RegistrationsController
    expose :user, build_params: :sign_up_params

    def create
      if user.save
        sign_in user
        redirect_to root_path, notice: t('.signed_up_successfully')
      else
        render :create, layout: false
      end
    end

    private

    def sign_up_params
      params.require(:user).permit(:email, :password, :first_name, :last_name, :password_confirmation)
    end
  end
end

app/controllers/users_controller.rb
# frozen_string_literal: true

class UsersController < ApplicationController
  expose :user

  before_action :redirect_if_user_not_found

  def update
    if user.update(permitted_params)
      redirect_to root_path, notice: t('.user_details_updated_successfully')
    else
      render :edit
    end
  end

  private

  def redirect_if_user_not_found
    redirect_to root_path, alert: t('.record_not_found') unless user
  end

  def permitted_params
    params.require(:user).permit(:email, :password, :first_name, :last_name, :password_confirmation)
  end
end

app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
  def inline_errors(object, attribute)
    return if object.errors[attribute].none?

    content_tag :p, object.errors[attribute].join(', '), class: 'text-red-500 text-xs italic'
  end

  def text_field_css(object, attribute)
    'border-red-500' if object.errors[attribute].any?
  end

  def flash_type_color(flash_type)
    case flash_type
    when 'alert' then 'bg-red-500'
    when 'notice' then 'bg-green-500'
    end
  end
end

app/helpers/posts_helper.rb
# frozen_string_literal: true

module PostsHelper
  def tag_list(post)
    post.tags.collect(&:name).join(', ')
  end
end

app/helpers/users_helper.rb
# frozen_string_literal: true

module UsersHelper
  def full_name(user)
    "#{user.first_name} #{user.last_name}"
  end
end

app/views/active_storage/blobs/_blob.html.erb
<figure class="attachment attachment--<%= blob.representable? ? "preview" : "file" %> attachment--<%= blob.filename.extension %>">
  <% if blob.representable? %>
    <%= image_tag blob.representation(resize_to_limit: local_assigns[:in_gallery] ? [ 800, 600 ] : [ 1024, 768 ]) %>
  <% end %>

  <figcaption class="attachment__caption">
    <% if caption = blob.try(:caption) %>
      <%= caption %>
    <% else %>
      <span class="attachment__name"><%= blob.filename %></span>
      <span class="attachment__size"><%= number_to_human_size blob.byte_size %></span>
    <% end %>
  </figcaption>
</figure>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>BlogManagementSystem</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= render 'shared/nav' %>
    <%= render 'shared/message' %>
    <%= yield %>
  </body>
</html>

app/views/posts/_form.html.erb
<%= form_for(post) do |f| %>
  <div class="max-w-full mx-3 mb-6">
    <%= f.label :title, t('.title'), class: 'block uppercase tracking-wide text-gray-600 text-xs font-bold mb-2" for="grid-title' %>
    <%= f.text_field :title, autofocus: true, autocomplete: "title", placeholder: t('.title'), class: "appearance-none rounded-none relative block w-full px-3 py-2 border border-gray-300 placeholder-gray-500 text-gray-600 rounded-t-md focus:outline-none focus:ring-indigo-500 focus:border-indigo-500 focus:z-10 sm:text-sm #{text_field_css(post, :title)}" %>
    <%= inline_errors post, :title %>
  </div>
  <div class="mx-3 mb-6">
    <%= f.label :description, t('.description'), class: 'block uppercase tracking-wide text-gray-600 text-xs font-bold mb-2" for="grid-description' %>
    <%= f.rich_text_area :description, class: "appearance-none rounded-none relative block w-full px-3 py-2 border border-gray-300 placeholder-gray-500 text-gray-600 rounded-t-md focus:outline-none focus:ring-indigo-500 focus:border-indigo-500 focus:z-10 sm:text-sm #{text_field_css(post, :description)}" %>
    <%= inline_errors post, :description %>
  </div>
  <div class="mx-3 mb-6 relative">
    <%= f.label :main_image, t('.main_image'), class: 'block uppercase tracking-wide text-gray-600 text-xs font-bold mb-2" for="grid-main-image' do %>
      <% if f.object.main_image.attached? %>
        <%= t('.attached_file', file_name: f.object.main_image.filename) %>
      <% else %>
        <%= t('.pick_new_file') %>
      <% end %>
    <% end %>
    <%= f.file_field :main_image, accept: 'image/png,image/jpg,image/jpeg', class: "appearance-none rounded-none  block w-full px-3 py-2 border border-gray-300 placeholder-gray-500 text-gray-900 rounded-t-md focus:outline-none focus:ring-indigo-500 focus:border-indigo-500 focus:z-10 sm:text-sm #{text_field_css(post, :main_image)}" %>
    <%= inline_errors post, :main_image %>
  </div>
  <div class="mx-3 mb-6 relative">
    <%= f.label :tag_list, t('.tags'), class: 'block uppercase tracking-wide text-gray-600 text-xs font-bold mb-2" for="grid-tags' %>
    <%= f.text_field :tag_list, class: "appearance-none rounded-none relative block w-full px-3 py-2 border border-gray-300 placeholder-gray-500 text-gray-900 rounded-t-md focus:outline-none focus:ring-indigo-500 focus:border-indigo-500 focus:z-10 sm:text-sm #{text_field_css(post, :description)}" %>
  </div>
  <div class="actions">
    <%= f.submit t('.submit'), class: "group relative w-full flex justify-center py-2 px-4 border border-transparent text-sm font-medium rounded-md text-white bg-indigo-600 hover:bg-indigo-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500" %>
  </div>
<% end %>

app/views/posts/_post.html.erb
<div class="grid rounded overflow-hidden shadow-lg">
  <div class="px-6 py-4">
    <div class="font-bold text-gray-500 text-xl mb-2"><%= post.title %></div>
    <p class="text-gray-500 text-base">
      <%= post.description.to_plain_text.truncate(70, omission: '') %>
      <%= link_to t('.read_more'), post_path(post.id), class: 'text-blue-500' %>
    </p>
  </div>
  <% if post.tags.present? %>
    <div class="px-6 pt-4 pb-2">
      <% post.tags.each do |tag| %>
        <span class="inline-block bg-gray-200 rounded-full px-3 py-1 text-sm font-semibold text-gray-600 mr-2 mb-2">
          <svg class="inline flex-shrink-0 mr-1.5 h-5 w-5 text-gray-400" xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-tag"><path d="M20.59 13.41l-7.17 7.17a2 2 0 0 1-2.83 0L2 12V2h10l8.59 8.59a2 2 0 0 1 0 2.82z"></path><line x1="7" y1="7" x2="7.01" y2="7"></line></svg>
          <%= tag.name %>
        </span>
      <% end %>
    </div>
  <% end %>
  <% if post.published_at.present? %>
    <div class="px-6">
      <span class="inline-block bg-pink-200 rounded-full px-3 py-1 text-sm font-semibold text-gray-600 mr-2 mb-2">
          <svg class="inline flex-shrink-0 mr-1.5 h-5 w-5 text-gray-400" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" aria-hidden="true">
            <path fill-rule="evenodd" d="M6 2a1 1 0 00-1 1v1H4a2 2 0 00-2 2v10a2 2 0 002 2h12a2 2 0 002-2V6a2 2 0 00-2-2h-1V3a1 1 0 10-2 0v1H7V3a1 1 0 00-1-1zm0 5a1 1 0 000 2h8a1 1 0 100-2H6z" clip-rule="evenodd" />
          </svg>
          <%= t('.published_at', time: post.published_at&.to_s(:db)) %>
      </span>
    </div>
  <% end %>
  <% if params[:own_posts] %>
    <div class="place-content-center px-6 pt-4 grid grid-flow-col gap-2 auto-rows-auto mb-3">
      <%= link_to t('.edit'), edit_post_path(post.id), class: 'text-center h-auto px-1 py-1 border border-transparent text-md font-medium rounded-md text-white bg-blue-600 hover:bg-blue-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-blue-500' %>
      <%= link_to t('.delete'), post_path(post.id), method: :delete, class: 'text-center h-auto px-1 py-1 border border-transparent text-md font-medium rounded-md text-white bg-red-600 hover:bg-red-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-red-500' %>
      <% if post.draft? %>
        <%= link_to t('.publish'), publish_post_path(post.id), method: :put, class: 'text-center h-auto px-1 py-1 border border-transparent text-md font-medium rounded-md text-white bg-green-600 hover:bg-green-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-green-500' %>
      <% end %>
      <% if post.main_image.attached? %>
        <%= link_to t('.remove_image'), delete_main_image_attachment_post_url(post.main_image.id), method: :delete, class: 'text-center h-auto px-1 py-1 border border-transparent text-md font-medium rounded-md text-white bg-pink-600 hover:bg-pink-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-pink-500' %>
      <% end %>
    </div>
  <% else %>
    <div class="px-6 pt-4 pb-2">
      <span class="inline-block bg-green-200 rounded-full px-3 py-1 text-sm font-semibold text-gray-500 mr-2 mb-2">
        <svg class="inline flex-shrink-0 mr-1.5 h-5 w-5 text-gray-400" version="1.1" id="Capa_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
           width="45.532px" height="45.532px" viewBox="0 0 45.532 45.532" style="enable-background:new 0 0 45.532 45.532;"
           xml:space="preserve">
          <g>
            <path d="M22.766,0.001C10.194,0.001,0,10.193,0,22.766s10.193,22.765,22.766,22.765c12.574,0,22.766-10.192,22.766-22.765
              S35.34,0.001,22.766,0.001z M22.766,6.808c4.16,0,7.531,3.372,7.531,7.53c0,4.159-3.371,7.53-7.531,7.53
              c-4.158,0-7.529-3.371-7.529-7.53C15.237,10.18,18.608,6.808,22.766,6.808z M22.761,39.579c-4.149,0-7.949-1.511-10.88-4.012
              c-0.714-0.609-1.126-1.502-1.126-2.439c0-4.217,3.413-7.592,7.631-7.592h8.762c4.219,0,7.619,3.375,7.619,7.592
              c0,0.938-0.41,1.829-1.125,2.438C30.712,38.068,26.911,39.579,22.761,39.579z"/>
          </g>
        </svg>
        <%= full_name(post.user) %>
      </span>
    </div>
  <% end %>
</div>

app/views/posts/edit.html.erb
<div class="flex items-center justify-center py-12 px-12 sm:px-12 lg:px-12">
  <div class="max-w-2xl w-full space-y-8">
    <h2 class="mt-6 text-center text-3xl font-bold text-yellow-600">
      <%= t('.edit_post') %>
    </h2>
    <%= render 'form', post: post %>
  </div>
</div>

app/views/posts/index.html.erb
<div class="container mx-auto px-10">
  <h2 class="mt-6 text-center text-3xl font-bold text-yellow-600">
    <%= t('.posts') %>
  </h2>
  <% if posts.present? %>
    <div class="m-10 grid grid-cols-1 sm:grid-cols-3 md:grid-cols-3 lg:grid-cols-3 xl:grid-cols-3 gap-5">
      <% cache [posts, params[:own_posts]] do %>
        <%= render posts %>
      <% end %>
    </div>
    <div class="text-center my-4">
      <%= will_paginate posts %>
    </div>
  <% else %>
    <div class="text-center p-10 text-blue-700" role="alert">
      <p class="text-sm text-lg">
        <% if params[:own_posts] %>
          <%= t('.no_posts_created') %>
        <% else %>
          <%= t('.no_published_post') %>
        <% end %>
      </p>
    </div>
  <% end %>
</div>

app/views/posts/new.html.erb
<div class="flex items-center justify-center py-12 px-4 sm:px-6 lg:px-8">
  <div class="max-w-4xl w-full space-y-8">
    <h2 class="mt-6 text-center text-3xl font-bold text-yellow-600">
      <%= t('.add_new_post') %>
    </h2>
    <%= render 'form', post: post %>
  </div>
</div>

app/views/posts/show.html.erb
<div class="mt-10 rounded overflow-hidden shadow-lg container mx-auto">
  <div class="py-12 px-4 sm:px-6 lg:px-8">
    <% if @post.main_image.attached? %>
      <div class="w-6/12 sm:w-4/12">
        <img src="<%=(url_for(@post.main_image.variant(resize: '100x100')))%>" class="shadow rounded-full max-w-full h-auto align-middle border-none" />
      </div>
    <% end %>
    <div class="min-w-0">
      <h2 class="text-2xl font-bold leading-7 text-gray-500 sm:text-3xl sm:truncate">
        <%= @post.title %>
      </h2>
      <span class="h-min w-min whitespace-nowrap py-1 mt-2 bg-green-500 px-2 text-md rounded-full flex items-center text-sm text-white">
        <svg class="inline flex-shrink-0 mr-1.5 h-5 w-5 text-gray-400" version="1.1" id="Capa_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
           width="45.532px" height="45.532px" viewBox="0 0 45.532 45.532" style="enable-background:new 0 0 45.532 45.532;"
           xml:space="preserve">
          <g>
            <path d="M22.766,0.001C10.194,0.001,0,10.193,0,22.766s10.193,22.765,22.766,22.765c12.574,0,22.766-10.192,22.766-22.765
              S35.34,0.001,22.766,0.001z M22.766,6.808c4.16,0,7.531,3.372,7.531,7.53c0,4.159-3.371,7.53-7.531,7.53
              c-4.158,0-7.529-3.371-7.529-7.53C15.237,10.18,18.608,6.808,22.766,6.808z M22.761,39.579c-4.149,0-7.949-1.511-10.88-4.012
              c-0.714-0.609-1.126-1.502-1.126-2.439c0-4.217,3.413-7.592,7.631-7.592h8.762c4.219,0,7.619,3.375,7.619,7.592
              c0,0.938-0.41,1.829-1.125,2.438C30.712,38.068,26.911,39.579,22.761,39.579z"/>
          </g>
        </svg>
        <%= full_name(@post.user) %>
      </span>
      <div class="mt-1 flex flex-col sm:flex-row sm:flex-wrap sm:mt-0 sm:space-x-6">
        <% if @post.published_at.present? %>
          <div class="mt-2 flex items-center text-sm text-gray-500">
            <svg class="flex-shrink-0 mr-1.5 h-5 w-5 text-gray-400" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" aria-hidden="true">
              <path fill-rule="evenodd" d="M6 2a1 1 0 00-1 1v1H4a2 2 0 00-2 2v10a2 2 0 002 2h12a2 2 0 002-2V6a2 2 0 00-2-2h-1V3a1 1 0 10-2 0v1H7V3a1 1 0 00-1-1zm0 5a1 1 0 000 2h8a1 1 0 100-2H6z" clip-rule="evenodd" />
            </svg>
            <%= t('.published_at', time: @post.published_at&.to_s(:db)) %>
          </div>
        <% end %>
        <% if @post.tags.present? %>
          <div class="mt-2 flex items-center text-sm text-gray-500">
            <svg class="flex-shrink-0 mr-1.5 h-5 w-5 text-gray-400" xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-tag"><path d="M20.59 13.41l-7.17 7.17a2 2 0 0 1-2.83 0L2 12V2h10l8.59 8.59a2 2 0 0 1 0 2.82z"></path><line x1="7" y1="7" x2="7.01" y2="7"></line></svg>
            <%= tag_list(post) %>
          </div>
        <% end %>
      </div>
    </div>
  </div>
  <div class="overflow-hidden">
    <h3 class="px-7 text-lg leading-6 font-medium text-gray-600">
      <%= t('.description') %>
    </h3>
    <div class="px-7 py-5">
      <%= @post.description %>
    </div>
  </div>
</div>

app/views/shared/_message.html.erb
<% if flash.any? %>
  <div class="fixed inset-0 flex items-end justify-center px-6 py-6 pointer-events-none sm:m-10 sm:pt-10 sm:items-start sm:justify-end z-50" data-flash-notifications='true'>

    <% flash.each do |msg_type, msg| %>

      <div x-data="{flashVisible: false, flashType: '<%= msg_type %>'}" x-show='flashVisible' x-init="() => {flashVisible=true; setTimeout(() => {flashVisible=false}, 5000)}" class="max-w-sm w-full bg-white shadow-lg rounded-lg pointer-events-auto"
           x-transition:enter="transition ease-out duration-300"
           x-transition:enter-start="translate-y-2 opacity-0 sm:translate-y-0 sm:translate-x-2"
           x-transition:enter-end="translate-y-0 opacity-100 sm:translate-x-0"
           x-transition:leave="transition ease-out duration-100"
           x-transition:leave-start="transform opacity-100"
           x-transition:leave-end="transform opacity-0">
        <div class="rounded-lg shadow-xs overflow-hidden <%= flash_type_color(msg_type) %>">
          <div class="p-4">
            <div class="flex items-start">
              <div class="flex-shrink-0">
                <svg class="h-6 w-6 text-gray-400" fill="none" viewBox="0 0 24 24" stroke="currentColor"
                     x-bind:class="{'text-green-400': flashType == 'success', 'text-red-500': flashType == 'error', 'text-yellow-300': flashType == 'alert'}">
                  <path x-show="flashType == 'success'" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M9 12l2 2 4-4m6 2a9 9 0 11-18 0 9 9 0 0118 0z" />
                  <path x-show="flashType == 'alert'" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M12 8v4m0 4h.01M21 12a9 9 0 11-18 0 9 9 0 0118 0z"/>
                  <path x-show="flashType == 'error'" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M12 9v2m0 4h.01m-6.938 4h13.856c1.54 0 2.502-1.667 1.732-3L13.732 4c-.77-1.333-2.694-1.333-3.464 0L3.34 16c-.77 1.333.192 3 1.732 3z"/>
                  <path x-show="flashType == 'notice'" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M13 16h-1v-4h-1m1-4h.01M21 12a9 9 0 11-18 0 9 9 0 0118 0z"/>
                </svg>
              </div>
              <div class="ml-3 w-0 flex-1 pt-0.5">
                <p class="text-sm leading-5 font-medium text-gray-900">
                  <%= msg %>
                </p>
              </div>
            </div>
          </div>
        </div>
      </div>

    <% end %>

  </div>
<% end %>

app/views/shared/_nav.html.erb
<!-- This example requires Tailwind CSS v2.0+ -->
<nav class="bg-gray-800">
  <div class="max-w-7xl mx-auto px-2 sm:px-6 lg:px-8">
    <div class="relative flex items-center justify-between h-16">
      <div class="flex-1 flex items-center justify-center sm:items-stretch sm:justify-start">
        <div class="flex-shrink-0 flex items-center">
          <%= link_to image_tag('blog-icon.png', class: 'hidden lg:block h-8 w-auto'), root_path %>
        </div>
        <% if user_signed_in? %>
          <div class="hidden sm:block sm:ml-6">
            <div class="flex space-x-4">
              <%= link_to t('.manage_posts'), posts_path(own_posts: true), class: 'bg-gray-900 text-white px-3 py-2 rounded-md text-sm font-medium' %>
              <%= link_to t('.add_new_post'), new_post_path, class: 'bg-gray-900 text-white px-3 py-2 rounded-md text-sm font-medium' %>
            </div>
          </div>
        <% end %>
      </div>
      <div class="absolute inset-y-0 right-0 flex items-center pr-2 sm:static sm:inset-auto sm:ml-6 sm:pr-0">
        <div class="flex space-x-4">
          <% if user_signed_in? %>
            <%= link_to t('.edit_profile'), edit_user_path(current_user.id), class: "bg-gray-900 text-white px-3 py-2 rounded-md text-sm font-medium" %>
            <%= link_to t('.sign_out'), destroy_user_session_path, method: :delete, class: "bg-gray-900 text-white px-3 py-2 rounded-md text-sm font-medium" %>
          <% else %>
            <%= link_to t('.sign_in'), new_user_session_path, class: "bg-gray-900 text-white px-3 py-2 rounded-md text-sm font-medium" %>
            <%= link_to t('.sign_up'), new_user_register_path, class: "bg-gray-900 text-white px-3 py-2 rounded-md text-sm font-medium" %>
          <% end %>
      </div>
    </div>
  </div>
</nav>